
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include <limits.h>

#include "base/polyOpts.h"
#include "runtime/LogComment.h"
#include "runtime/SharedOpts.h"
#include "app/DebugSwitch.h"


void DebugSignal(int s) {
	clog << "got debug signal (" << s << ')';

	static bool enable = true;
	static DumpFlagsOpt opts(TheOpts.theDumpFlags);
	static int echoLevel = -1;

	if (enable) {
		clog << " detailed debugging enabled";

		opts = TheOpts.theDumpFlags;
		echoLevel = Comment.TheEchoLevel;

		TheOpts.theDumpFlags.setAll();
		Comment.TheEchoLevel = INT_MAX;
	} else {
		clog << " reverting to configured debugging level";

		TheOpts.theDumpFlags = opts;
		Comment.TheEchoLevel = echoLevel;
	}

	clog << endl;
	enable = !enable;
}
