
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_CONNECTION_MANAGER_H
#define PG_CLIENT_CONNECTION_MANAGER_H

#include "xstd/NetAddr.h"
#include "xstd/Queue.h"
#include "client/ConnHash.h"
#include "runtime/ConnMgr.h"

class RobotSym;
class PortMgr;

class CltConnMgr: public ConnMgr {
	public:
		CltConnMgr();
		virtual ~CltConnMgr();

		void configure(const SockOpt &anOpt, const RobotSym *cfg, int srvCnt);
		void portMgr(PortMgr *aPortMgr);

		bool atHardConnLimit() const; 
		virtual Connection *get(const NetAddr &addr);

		virtual void noteReadReady(int fd);

	protected:
		bool findIdleSubst(const NetAddr &addr, ConnHashPos &pos);

		Connection *open(const NetAddr &addr);
		virtual void putIdle(Connection *conn);
		virtual void delIdle(Connection *conn);

	protected:
		ConnHash theIdleHash;
		Queue<Connection> theIdleQueue;
		PortMgr *thePortMgr;

		double theMinNewConnProb; // try limit #open() calls using substitutes
		int theConnLvlLmt;        // limit for #opened connections
};

#endif
