
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "runtime/LogComment.h"
#include "runtime/polyBcastChannels.h"
#include "client/WssFreezer.h"

int WssFreezer::TheStartCount = 0;

void WssFreezer::start() {
	Assert(!TheStartCount); // multiple wss freezers are not supported
	TheStartCount++;
	startFill();
}

void WssFreezer::startFill() {
	printGoal(Comment(5) << "fyi: working set size goal: ");
	Comment << endc;
	Broadcast(TheInfoChannel, BcastRcver::ieWssFill);
}

void WssFreezer::startFreeze() {
	Comment(5) << "fyi: started freezing working set size" << endc;
	Broadcast(TheInfoChannel, BcastRcver::ieWssFreeze);
}
