
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_AGENT_ARRAY_ITERATOR_H
#define PG_AGENT_ARRAY_ITERATOR_H

#include "pgl/HostsBasedIter.h"

class AgentSym;

// agent array iterator, based on HostsBasedIter
class AgentArrIter: public HostsBasedIter {
	public:
		typedef Array<AgentSym*> CfgSyms;

	public:
		AgentArrIter(const String &anAgentType);
		AgentArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs, const String &anAgentType);

		AgentSym *agentSym();
		virtual int cfgCount() const;

	protected:
		virtual bool belongs(const HostsBasedSym *cfgSym, const NetAddr &host) const;
		HostsBasedSym *cfgSym(int idx) const;

	protected:
		CfgSyms theCfgs;
		String theAgentType;  // iterate through agents of this type
};

#endif
