
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglRec.h"
#include "pgl/PglPopDistrSym.h"
#include "pgl/PopModelSym.h"


PopModelSym::PopModelSym(): RecSym("PopModel", new PglRec) {
	theRec->bAdd("PopDistr", "pop_distr", 0);
	theRec->bAdd("float", "hot_set_frac", 0);
	theRec->bAdd("float", "hot_set_prob", 0);
}

PopModelSym::PopModelSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool PopModelSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "PopModel";
}

SynSym *PopModelSym::dupe(const String &type) const {
	if (isA(type))
		return new PopModelSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}

PopDistr *PopModelSym::popDistr() const {
	SynSymTblItem *pdi = 0;
	Assert(theRec->find("pop_distr", pdi));
	return pdi->sym() ?
		((PopDistrSym&)pdi->sym()->cast("PopDistr")).val() : 0;
}

bool PopModelSym::hotSetFrac(double &ratio) const {
	return getDouble("hot_set_frac", ratio);
}

bool PopModelSym::hotSetProb(double &prob) const {
	return getDouble("hot_set_prob", prob);
}
