
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_PROXY_SYMBOL_H
#define PG_PROXY_SYMBOL_H

#include "pgl/AgentSym.h"

class RobotSym;
class ServerSym;
class CacheSym;

// server side configuration
class ProxySym: public AgentSym {
	public:
		ProxySym();
		ProxySym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		RobotSym *client() const;
		ServerSym *server() const;
		CacheSym *cache() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
