
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglIntSym.h"
#include "pgl/PglRec.h"
#include "pgl/RLimitsSym.h"


RLimitsSym::RLimitsSym(): RecSym("RLimits", new PglRec) {

	// add fields

	theRec->bAdd("int", "fds", 0);
}

RLimitsSym::RLimitsSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool RLimitsSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "RLimits";
}

SynSym *RLimitsSym::dupe(const String &type) const {
	if (isA(type))
		return new RLimitsSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}
