
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_RPTMSTAT_SYMBOL_H
#define PGL_RPTMSTAT_SYMBOL_H

#include "xstd/Time.h"
#include "pgl/PglRecSym.h"

// run goal specification
class RptmstatSym: public RecSym {
	public:
		RptmstatSym();
		RptmstatSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		bool configured() const;

		Time sampleDur() const;
		bool loadDelta(double &loadDelta) const;
		Time rptmMin() const;
		Time rptmMax() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
