
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglBoolSym.h"
#include "pgl/PglRec.h"
#include "pgl/PglTimeSym.h"
#include "pgl/SocketSym.h"


SocketSym::SocketSym(): RecSym("Socket", new PglRec) {

	// add fields

	theRec->bAdd("bool", "nagle", new BoolSym(false));
	theRec->bAdd("time", "linger_tout", 0);
}

SocketSym::SocketSym(String const &aType, PglRec *aRec):
	RecSym(aType, aRec) {
}

bool SocketSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "Socket";
}

SynSym *SocketSym::dupe(const String &type) const {
	if (isA(type))
		return new SocketSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}

bool SocketSym::lingerTout(Time &tout) const {
	SynSymTblItem *touti = 0;
	Assert(theRec->find("linger_tout", touti));
	if (touti->sym())
		tout = ((const TimeSym&)touti->sym()->cast("time")).val();
	return touti->sym() != 0;
}

bool SocketSym::nagle(bool &doNagle) const {
	SynSymTblItem *ni = 0;
	Assert(theRec->find("nagle", ni));
	if (ni->sym())
		doNagle = ((const BoolSym&)ni->sym()->cast("bool")).val();
	return ni->sym() != 0;
}
